=== ajalibraries/ajantv2/CMakeLists.txt ===
project(ajantv2)

if(CMAKE_CXX_STANDARD LESS 11)
    remove_definitions(
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)
endif()

remove_definitions(
    -DUNICODE
    -D_UNICODE
    -DQT_LARGEFILE_SUPPORT)

set(AJANTV2_TARGET_INCLUDE_DIRS
    includes
    ${AJA_LIB_ANC_ROOT}/includes
    ${AJA_LIBRARIES_ROOT}
    ${AJA_LIB_BASE_ROOT}
    ${CMAKE_CURRENT_BINARY_DIR})

# ajantv2
set(AJANTV2_HEADERS
    includes/ajaexport.h
    includes/ajatypes.h
    includes/basemachinecontrol.h
    includes/ntv2audiodefines.h
    includes/ntv2bft.h
    includes/ntv2bitfile.h
    includes/ntv2bitfilemanager.h
    includes/ntv2boardfeatures.h
    includes/ntv2boardscan.h
    includes/ntv2card.h
    includes/ntv2choosableboard.h
    includes/ntv2config2022.h
    includes/ntv2config2110.h
    includes/ntv2configts2022.h
    includes/ntv2cscmatrix.h
    includes/ntv2debug.h
    includes/ntv2debugmacros.h
    includes/ntv2devicefeatures.h
    includes/ntv2devicefeatures.hh # generated by sdkgen
    src/ntv2devicefeatures.hpp # generated by sdkgen
    includes/ntv2devicescanner.h
    includes/ntv2discover.h
    includes/ntv2driverinterface.h
    includes/ntv2endian.h
    includes/ntv2enhancedcsc.h
    includes/ntv2enums.h
    includes/ntv2fixed.h
    includes/ntv2formatdescriptor.h
    includes/ntv2konaflashprogram.h
    includes/ntv2m31enums.h
    includes/ntv2m31publicinterface.h
    includes/ntv2mailbox.h
    includes/ntv2mbcontroller.h
    includes/ntv2mcsfile.h
    includes/ntv2nubaccess.h
    includes/ntv2nubpktcom.h
    includes/ntv2nubtypes.h
    includes/ntv2publicinterface.h
    includes/ntv2registerexpert.h
    includes/ntv2registers2022.h
    includes/ntv2registers2110.h
    includes/ntv2registersmb.h
    includes/ntv2resample.h
    includes/ntv2routingexpert.h
    includes/ntv2rp188.h
    includes/ntv2rp215.h
    includes/ntv2serialcontrol.h
    includes/ntv2signalrouter.h
    includes/ntv2spiinterface.h
    includes/ntv2supportlogger.h
    includes/ntv2task.h
    includes/ntv2testpatterngen.h
    includes/ntv2transcode.h
    includes/ntv2tshelper.h
    includes/ntv2utf8.h
    includes/ntv2utils.h
    includes/ntv2verticalfilter.h
    includes/ntv2videodefines.h
    includes/ntv2virtualregisters.h
    includes/ntv2vpid.h
    includes/ntv2vpidfromspec.h)
set(AJANTV2_SOURCES
    src/ntv2anc.cpp
    src/ntv2audio.cpp
    src/ntv2autocirculate.cpp
    src/ntv2bitfile.cpp
    src/ntv2bitfilemanager.cpp
    src/ntv2card.cpp
    src/ntv2config2022.cpp
    src/ntv2config2110.cpp
    src/ntv2configts2022.cpp
    src/ntv2csclut.cpp
    src/ntv2cscmatrix.cpp
    src/ntv2debug.cpp
    src/ntv2devicefeatures.cpp
    src/ntv2devicescanner.cpp
    src/ntv2discover.cpp
    src/ntv2dma.cpp
    src/ntv2driverinterface.cpp
    src/ntv2dynamicdevice.cpp
    src/ntv2enhancedcsc.cpp
    src/ntv2formatdescriptor.cpp
    src/ntv2hdmi.cpp
    src/ntv2hevc.cpp
    src/ntv2interrupts.cpp
    src/ntv2konaflashprogram.cpp
    src/ntv2mailbox.cpp
    src/ntv2mbcontroller.cpp
    src/ntv2mcsfile.cpp
    src/ntv2nubaccess.cpp
    src/ntv2nubpktcom.cpp
    src/ntv2publicinterface.cpp
    src/ntv2register.cpp
    src/ntv2registerexpert.cpp
    src/ntv2resample.cpp
    src/ntv2routingexpert.cpp
    src/ntv2rp188.cpp
    src/ntv2rp215.cpp
    src/ntv2serialcontrol.cpp
    src/ntv2signalrouter.cpp
    src/ntv2spiinterface.cpp
    src/ntv2subscriptions.cpp
    src/ntv2supportlogger.cpp
    src/ntv2task.cpp
    src/ntv2testpatterngen.cpp
    src/ntv2transcode.cpp
    src/ntv2utf8.cpp
    src/ntv2utils.cpp
    src/ntv2verticalfilter.cpp
    src/ntv2vpid.cpp
    src/ntv2vpidfromspec.cpp)
# ntv2driverinterface/publicinterface
set(AJANTV2_WIN_HEADERS
    src/win/ntv2windriverinterface.h
    src/win/ntv2winpublicinterface.h)
set(AJANTV2_WIN_SOURCES
    # src/win/dllmain.cpp
    src/win/ntv2windriverinterface.cpp)
set(AJANTV2_MAC_HEADERS
    src/mac/ntv2macdriverinterface.h
    src/mac/ntv2macpublicinterface.h)
set(AJANTV2_MAC_SOURCES
    src/mac/ntv2macdriverinterface.cpp)
set(AJANTV2_LIN_HEADERS
    src/lin/ntv2linuxdriverinterface.h
    src/lin/ntv2linuxpublicinterface.h)
set(AJANTV2_LIN_SOURCES
    src/lin/ntv2linuxdriverinterface.cpp)
# ajantv2 utilityfiles
set(AJANTV2_UTILITY_PUBLIC_HEADERS
    utilityfiles/public/ntv2firmwareinstallerthread.h
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.h)
set(AJANTV2_UTILITY_PUBLIC_SOURCES
    utilityfiles/public/ntv2firmwareinstallerthread.cpp
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.cpp)
# ajantv2 hevc
if (NOT AJA_BUILD_OPENSOURCE)
    aja_message(STATUS "added ajantv2 HEVC/M31 codec")
    set(AJANTV2_HEVC_HEADERS
        codecs/hevc/m31/ntv2m31.h
        codecs/hevc/m31/ntv2m31cparam.h
        codecs/hevc/m31/ntv2m31ehparam.h
        codecs/hevc/m31/ntv2m31vaparam.h
        codecs/hevc/m31/ntv2m31vinparam.h
        codecs/hevc/m31/ntv2m31viparam.h)
    set(AJANTV2_HEVC_SOURCES
        codecs/hevc/m31/ntv2m31.cpp
        codecs/hevc/m31/ntv2m31cparam.cpp
        codecs/hevc/m31/ntv2m31ehparam.cpp
        codecs/hevc/m31/ntv2m31vaparam.cpp
        codecs/hevc/m31/ntv2m31vinparam.cpp
        codecs/hevc/m31/ntv2m31viparam.cpp)
    # `cmake --install` deployments
    if (AJA_INSTALL_HEADERS)
        install(FILES ${AJANTV2_HEVC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajalibraries/ajantv2/codecs/hevc/m31)
    endif()
    if (AJA_INSTALL_SOURCES)
        install(FILES ${AJANTV2_HEVC_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajalibraries/ajantv2/codecs/hevc/m31)
    endif()
endif()

if (AJA_BUILDING_CMAKE)
    add_definitions(-DAJA_BUILDING_CMAKE)
    configure_file(includes/version.h.in includes/version.h @ONLY)
    install(FILES ${CMAKE_BINARY_DIR}/ajalibraries/ajantv2/includes/version.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajalibraries/ajantv2/includes)
endif()

# ajaanc
set(AJAANC_HEADERS
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydatafactory.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608_line21.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608_vanc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea708.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_framestatusinfo524D.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_framestatusinfo5251.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_hdr10.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_hlg.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_sdr.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode_atc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode_vitc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarylist.h)
set(AJAANC_SOURCES
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydatafactory.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608_line21.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608_vanc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea708.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_framestatusinfo524D.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_framestatusinfo5251.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_hdr10.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_hlg.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_sdr.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode_atc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode_vitc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarylist.cpp)

# ajabase
set(AJABASE_COMMON_HEADERS
    ${AJA_LIB_BASE_ROOT}/common/ajarefptr.h
    ${AJA_LIB_BASE_ROOT}/common/audioutilities.h
    ${AJA_LIB_BASE_ROOT}/common/buffer.h
    ${AJA_LIB_BASE_ROOT}/common/bytestream.h
    ${AJA_LIB_BASE_ROOT}/common/circularbuffer.h
    ${AJA_LIB_BASE_ROOT}/common/cli_utils.h
    ${AJA_LIB_BASE_ROOT}/common/common.h
    ${AJA_LIB_BASE_ROOT}/common/dpxfileio.h
    ${AJA_LIB_BASE_ROOT}/common/dpx_hdr.h
    ${AJA_LIB_BASE_ROOT}/common/export.h
    ${AJA_LIB_BASE_ROOT}/common/guid.h
    ${AJA_LIB_BASE_ROOT}/common/options_popt.h
    ${AJA_LIB_BASE_ROOT}/common/performance.h
    ${AJA_LIB_BASE_ROOT}/common/pixelformat.h
    ${AJA_LIB_BASE_ROOT}/common/public.h
    ${AJA_LIB_BASE_ROOT}/common/rawfile.h
    ${AJA_LIB_BASE_ROOT}/common/testpatterngen.h
    ${AJA_LIB_BASE_ROOT}/common/timebase.h
    ${AJA_LIB_BASE_ROOT}/common/timecode.h
    ${AJA_LIB_BASE_ROOT}/common/timecodeburn.h
    ${AJA_LIB_BASE_ROOT}/common/timer.h
    ${AJA_LIB_BASE_ROOT}/common/types.h
    ${AJA_LIB_BASE_ROOT}/common/videotypes.h
    ${AJA_LIB_BASE_ROOT}/common/videoutilities.h
    ${AJA_LIB_BASE_ROOT}/common/wavewriter.h)
set(AJABASE_NETWORK_HEADERS
    ${AJA_LIB_BASE_ROOT}/network/ip_socket.h
    ${AJA_LIB_BASE_ROOT}/network/tcp_socket.h
    ${AJA_LIB_BASE_ROOT}/network/udp_socket.h)
set(AJABASE_PERSISTENCE_HEADERS
    ${AJA_LIB_BASE_ROOT}/persistence/persistence.h
    ${AJA_LIB_BASE_ROOT}/persistence/sqlite3.h)
set(AJABASE_PNP_HEADERS
    ${AJA_LIB_BASE_ROOT}/pnp/pnp.h)
set(AJABASE_SYS_HEADERS
    ${AJA_LIB_BASE_ROOT}/system/atomic.h
    ${AJA_LIB_BASE_ROOT}/system/debug.h
    ${AJA_LIB_BASE_ROOT}/system/debugshare.h
    ${AJA_LIB_BASE_ROOT}/system/diskstatus.h
    ${AJA_LIB_BASE_ROOT}/system/event.h
    ${AJA_LIB_BASE_ROOT}/system/file_io.h
    ${AJA_LIB_BASE_ROOT}/system/info.h
    ${AJA_LIB_BASE_ROOT}/system/lock.h
    ${AJA_LIB_BASE_ROOT}/system/log.h
    ${AJA_LIB_BASE_ROOT}/system/make_unique_shim.h
    ${AJA_LIB_BASE_ROOT}/system/memory.h
    ${AJA_LIB_BASE_ROOT}/system/process.h
    ${AJA_LIB_BASE_ROOT}/system/system.h
    ${AJA_LIB_BASE_ROOT}/system/systemtime.h
    ${AJA_LIB_BASE_ROOT}/system/thread.h)
set(AJABASE_COMMON_SOURCES
    ${AJA_LIB_BASE_ROOT}/common/audioutilities.cpp
    ${AJA_LIB_BASE_ROOT}/common/buffer.cpp
    ${AJA_LIB_BASE_ROOT}/common/common.cpp
    ${AJA_LIB_BASE_ROOT}/common/dpxfileio.cpp
    ${AJA_LIB_BASE_ROOT}/common/dpx_hdr.cpp
    ${AJA_LIB_BASE_ROOT}/common/guid.cpp
    ${AJA_LIB_BASE_ROOT}/common/options_popt.cpp
    ${AJA_LIB_BASE_ROOT}/common/performance.cpp
    ${AJA_LIB_BASE_ROOT}/common/pixelformat.cpp
    ${AJA_LIB_BASE_ROOT}/common/testpatterngen.cpp
    ${AJA_LIB_BASE_ROOT}/common/timebase.cpp
    ${AJA_LIB_BASE_ROOT}/common/timecode.cpp
    ${AJA_LIB_BASE_ROOT}/common/timecodeburn.cpp
    ${AJA_LIB_BASE_ROOT}/common/timer.cpp
    ${AJA_LIB_BASE_ROOT}/common/videoutilities.cpp
    ${AJA_LIB_BASE_ROOT}/common/wavewriter.cpp)
set(AJABASE_NETWORK_SOURCES
    ${AJA_LIB_BASE_ROOT}/network/ip_socket.cpp
    ${AJA_LIB_BASE_ROOT}/network/tcp_socket.cpp
    ${AJA_LIB_BASE_ROOT}/network/udp_socket.cpp)
set(AJABASE_PERSISTENCE_SOURCES
    ${AJA_LIB_BASE_ROOT}/persistence/persistence.cpp
    ${AJA_LIB_BASE_ROOT}/persistence/sqlite3.c)
set(AJABASE_PNP_SOURCES
    ${AJA_LIB_BASE_ROOT}/pnp/pnp.cpp)
set(AJABASE_SYS_SOURCES
    ${AJA_LIB_BASE_ROOT}/system/atomic.cpp
    ${AJA_LIB_BASE_ROOT}/system/debug.cpp
    ${AJA_LIB_BASE_ROOT}/system/diskstatus.cpp
    ${AJA_LIB_BASE_ROOT}/system/event.cpp
    ${AJA_LIB_BASE_ROOT}/system/file_io.cpp
    ${AJA_LIB_BASE_ROOT}/system/info.cpp
    ${AJA_LIB_BASE_ROOT}/system/lock.cpp
    ${AJA_LIB_BASE_ROOT}/system/log.cpp
    ${AJA_LIB_BASE_ROOT}/system/memory.cpp
    ${AJA_LIB_BASE_ROOT}/system/process.cpp
    ${AJA_LIB_BASE_ROOT}/system/system.cpp
    ${AJA_LIB_BASE_ROOT}/system/systemtime.cpp
    ${AJA_LIB_BASE_ROOT}/system/thread.cpp)
# ajabase windows
set(AJABASE_PNP_WIN_HEADERS
    ${AJA_LIB_BASE_ROOT}/pnp/windows/pnpimpl.h)
set(AJABASE_PNP_WIN_SOURCES
    ${AJA_LIB_BASE_ROOT}/pnp/windows/pnpimpl.cpp)
set(AJABASE_SYS_WIN_HEADERS
    ${AJA_LIB_BASE_ROOT}/system/windows/eventimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/infoimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/lockimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/processimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/threadimpl.h)
set(AJABASE_SYS_WIN_SOURCES
