=== debian/changelog ===
ntv2-dmo (16.2.5-dmo1) unstable; urgency=medium

  * Remove bugfix from upstream version. More eassy to manage.
  * Only build for amd64

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 05 Sep 2022 09:10:07 +0200

ntv2-dmo (16.2-bugfix5-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 01 Sep 2022 16:59:39 +0200
