=== debian/control ===
Source: ntv2-dmo
Section: libdevel
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/aja-video/ntv2
Rules-Requires-Root: no
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13), cmake, ninja-build

Package: libajantv2-dev
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AJA NTV2 SDK
 NTV2 SDK for AJA PCI cards.
