=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DAJA_BUILD_APPS=OFF \
	-DAJA_BUILD_OPENSOURCE=ON

#	exit 1

override_dh_clean:
	dh_clean ajadriver/mac/README.md ajadriver/win/README.md

override_dh_auto_test:
