=== debian/watch ===
version=4

https://github.com/aja-video/ntv2/tags \
(?:.*?/)?v?(\d[\d.]*)-bugfix?(\d[\d.]*)@ARCHIVE_EXT@
